from distutils.core import setup, Extension
import os, platform

extra_compile_args = None

if os.name == 'posix':
    extra_compile_args = ['-std=cpp++17']
else:
    extra_compile_args = ['/std:cpp++17']

mod = Extension('lngs',
                language='c++',
                sources=['src/py-lngs.cc'],
                libraries=['lngs_lite'],
                extra_compile_args=extra_compile_args)

setup(name = 'Lngs',
      version = '0.3',
      author = 'Marcin Zdun',
      author_email = 'mzdun@midnightbits.com',
      url = 'https://github.com/mbits-os/locale',
      description = 'Python bindings for lngs',
      long_description = '''\
Python version of classes reading locale strings.

Together with a module generated by 'lngs py' this module
allows to use lngs binary files from python scripts
''',
      license = 'MIT',
      platforms = [platform.system()],
      ext_modules = [mod])

